#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/App/StartSetup.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD
#


package SAPDB::Install::App::StartSetup;

use SAPDB::Install::LoadWx;
use Wx qw(wxICON_ERROR wxCENTRE);
use SAPDB::Install::Frame::StartSetup;
use SAPDB::Install::SigHandler;
use SAPDB::Install::Version;

our @ISA = qw (Wx::App);

# this is called automatically on object creation
sub OnInit {
  my( $this ) = @_;
	
  my $title = "MaxDB Installation Manager [$SAPDB::Install::Version::Version]";
  
  if (exists $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'}){
	$title .= ' - PORTABLE MODE';
  }
   	

  my( $frame ) = SAPDB::Install::Frame::StartSetup->new( $title,
			       [100, 100],
			       [680,470 ]
  );

  if (defined $SDB::Wx::Splash::Window) {
    $SDB::Wx::Splash::Window->Close ();
  }

  $this->SetTopWindow( $frame );
  $frame->Layout;
  $frame->Show(1);
  
  1;

}

sub OnExit{
	my ($self) = @_;
	print ">>>>> Closing App\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
	$self->Destroy;
}

sub Destroy{
	my ($self) = @_;
	print ">>>>>> destroy APP\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


sub main{
	setSigHandler;	
	my ( $app ) = SAPDB::Install::App::StartSetup->new();
	if(caller eq 'SAPDB::Install::Start'){
		# start processing events
		local $cleaner = SAPDB::Install::Cleaner->new();
		eval{
			$app->MainLoop();	
		};
		if($@ and $@ !~ /^SDB_closing/){
			if(defined $SAPDB::Install::Values::log){
				$SAPDB::Install::Values::log->SetMsg
					("fatal error: $@\n");
				$SAPDB::Install::Values::log->SetMsg("call stack:\n");
				my $frame = 0; 
				while(1){
					last unless(caller($frame));
					$SAPDB::Install::Values::log->SetMsg("#$frame ".join(' ',caller($frame ++))."\n");
				}
				$SAPDB::Install::Values::log->writeLog;
			}
			my $msgdlg = Wx::MessageDialog->new(undef,$@.
				"\n Please click OK button to exit the application...",
				"Fatal error", wxICON_ERROR | wxCENTRE);
			$msgdlg->ShowModal();
			$msgdlg->Destroy;
			$cleaner->DESTROY;
			if(defined $app->GetTopWindow){
				$app->GetTopWindow->Destroy;
			}
			return -1;
		}
	}
	$app = undef;
	return 0;
}

1;
