#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Base.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: 

package SAPDB::Install::Base;

#base class for all SAPDB::Install - Classes

require SDB::Common::Exporter;
our @ISA = qw (SDB::Common::Exporter);
our @EXPORT = qw (main);

use SAPDB::Install::StdIO;
use SAPDB::Install::Trace;

my %members=();


sub new{
	my $that = shift;
	my $class = ref($that) || $that;
	my $self ={
		%members,
	};
	my ($package,$file,$line) = caller;
	TraceMsg("create new object of class $package [in $file line $line]\n",4,\$DEBUG,3);
	bless $self,$class;
	return $self;
}

sub AUTOLOAD{
	my $self = shift;
	local *hash=$self;
	my ($package,$file,$line) = caller;
	my $type = ref($self) || print2stderr("FATAL ERROR: $AUTOLOAD(), \"$self\" is not an object, package: $package, file: $file, line: $line\n") && diesoft($SAPDB::Install::Values::diemsg);
	my $name = $AUTOLOAD;
	$name =~ s/.*://;

	$name =~ /destroy/i or exists $hash{$name} or print2stderr("FATAL ERROR: cannot access member \"$name\" of class \"$type\", package: $package, file: $file, line: $line\n") and diesoft($SAPDB::Install::Values::diemsg);
	if(@_){
		my $value = shift;
		if(exists $self->{'dirty'}){
			TraceMsg("dirty flag found in object\n",5,\$DEBUG,2);
			if(ref($value)){
				$value == $hash{$name} or $hash{'dirty'} = 1 and TraceMsg("set object dirty\n",5,\$DEBUG,2);
			}
			else{
				$value eq $hash{$name} or $hash{'dirty'} = 1 and TraceMsg("set object dirty\n",5,\$DEBUG,2);
			} 
		}
		exists $hash{'ID'} and my $id="(ID = ".$hash{'ID'}.")";
		TraceMsg("set $type$id->$name to $value [in $file line $line]\n",5,\$DEBUG,2);
		return $hash{$name} = $value;
	}
	else{
		exists $hash{'ID'} and my $id="(ID = ".$hash{'ID'}.")";
		TraceMsg("read $type$id->$name - value = ".$hash{$name}." [in $file line $line]\n",5,\$DEBUG,2);
		return $hash{$name};
	}
}

sub DESTROY{
	my ($self)=@_;
	my ($package,$file,$line) = caller;
	exists ${%$self}{'ID'} and my $id="(ID = ".${%$self}{'ID'}.")";
	TraceMsg("destroy an object of class $package $id\n",4,\$DEBUG,2);
}


1;