#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Dialog/DBLogin.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: 


package SAPDB::Install::Dialog::DBLogin;

use Wx::Event qw (EVT_CLOSE EVT_BUTTON);
use Wx qw ( wxVERTICAL wxBOTTOM
	wxEXPAND wxALL wxICON_ERROR wxCENTRE
	wxRIGHT wxALIGN_RIGHT wxHORIZONTAL);

use base Wx::Dialog;
use SAPDB::Install::Window::DBLogin;


#
#	$my_args = {
#				'dbname' => <database name>,
#				'log' => <a object of type SAPDB::Install::Log or with similar interface>,
#			};
#


sub new{
	my ($class,$my_args,@args) = @_;
	my($this ) = $class->SUPER::new(@args);
	$this->{'dbname'} = $my_args->{'dbname'};
	$this->SetTitle('Login to Database '.$my_args->{'dbname'});
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'login'} = SAPDB::Install::Window::DBLogin->new($my_args,$this,-1);
	$sizer->Add($this->{'login'},1,wxEXPAND | ((wxALL) & (~wxBOTTOM)),10);
	my $stop_button = Wx::Button->new($this,-1,'&Login');
	my $cancel_button = Wx::Button->new($this,-1,'&Cancel');
	
	EVT_BUTTON($this,$stop_button->GetId,\&OnLogin);
	EVT_BUTTON($this,$cancel_button->GetId,\&OnCancel);
	
	my $button_sizer = Wx::BoxSizer->new(wxHORIZONTAL);
	if(exists $my_args->{'log'} and defined $my_args->{'log'}){
		my $log = $my_args->{'log'};
		$this->{'msg0'} = sub {$log->SetMsg("MSG: $_[0]");};
		$this->{'msg1'} = $this->{'msg0'};
		$this->{'log'} = $my_args->{'log'};
	}	
	$button_sizer->Add($stop_button,0,wxRIGHT,10);
	$button_sizer->Add($cancel_button,0);
	$sizer->Add($button_sizer,0 , wxALL | wxALIGN_RIGHT  ,10);
	EVT_CLOSE($this,\&OnClose);
	$this->SetSizerAndFit($sizer);
	$this->SetAutoLayout(1);
	$this->Show(1);
	return $this;
}


sub OnLogin{
	my ($self,$evt) = @_;
	my $busy = Wx::BusyCursor->new();
	my $user = $self->{'login'}->GetUserName();
	my $pw = $self->{'login'}->GetPassword();
	
	if($user !~ /\S/){
		my $msgbox = Wx::MessageDialog->new($self,'Empty user name!','Missing Parameter',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}
	
	if($pw !~ /\S/){
		my $msgbox = Wx::MessageDialog->new($self,'Empty password!','Missing Parameter',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}
	$self->{'dbm'} = $self->{'login'}->connect();
	unless (defined $self->{'dbm'}){
		my $msgbox = Wx::MessageDialog->new($self,$self->{'login'}->{'last_err'},'Database Login Faild',wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal;
		$msgbox->Destroy;
		return undef;
	}	
	$self->{'login_data'} = $user.','.$pw;
	$self->EndModal(1);
}


sub OnCancel{
	my ($self,$evt) = @_;
	$self->EndModal(0);
}

sub OnClose{
	my ($self,$evt) = @_;
	$self->EndModal(0);
}

sub Destroy{
	my ($self) = @_;
	while($self->GetSizer->Remove(0)) {}
	$self->{'login'}->Destroy;
	delete $self->{'login'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;
