#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Dialog/InstallationView.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Dialog::InstallationView;

use Wx::Event qw (EVT_BUTTON EVT_KILL_FOCUS);
use Wx qw ( wxVERTICAL
	wxEXPAND wxALIGN_CENTER wxALL
	wxTOP wxBOTTOM);

use SAPDB::Install::Window::InstallationView;

use base Wx::Dialog;

sub new{
	my($this ) = shift->SUPER::new(@_);
	$this->Move([300,200]);
	$this->SetTitle('Show MaxDB Components');
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'view'} = SAPDB::Install::Window::InstallationView->new($this,-1);
	$this->{'view'}->init();
	$sizer->Add($this->{'view'},1,wxEXPAND | wxALL, 10);
	$this->{'button'} = Wx::Button->new($this,-1,'&OK',[0,0],[-1,-1]);
	$sizer->Add($this->{'button'},0,wxALIGN_CENTER | wxBOTTOM, 10);	
	$this->SetSizerAndFit($sizer);
	EVT_BUTTON($this,$this->{'button'}->GetId,sub {my ($self) = @_; $self->Close(1);});
	$this->{'button'}->SetFocus;
	$this->{'button'}->SetDefault;
	$this->SetDefaultItem($this->{'button'});
	$this->Layout;
	$this->ShowModal;
	return $this;
}

sub Destroy{
	my ($self) = @_;
	while($self->GetSizer->Remove(0)) {}
	$self->{'view'}->Destroy;
	delete $self->{'view'};
	$self->{'button'}->Destroy;
	delete $self->{'button'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;
