#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Dialog/PackageView.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD

package myPackageList;

use base SAPDB::Install::Window::ItemList;
use Wx qw(wxALIGN_RIGHT);

our @cols = (	
		{
			'key' => 'name',
			'label' => 'Package Name'
		},
		{
			'key' => 'size',
			'label' => 'Size in MB',
			'alignment' => wxALIGN_RIGHT
		},
		{
			'key' => 'version',
			'label' => 'Version'
		}
);

1;

package SAPDB::Install::Dialog::PackageView;

use Wx::Event qw (EVT_BUTTON EVT_KILL_FOCUS
					EVT_SET_FOCUS);
use Wx qw ( wxVERTICAL
	wxEXPAND wxALIGN_CENTER wxALL
	wxTOP wxBOTTOM wxTAB_TRAVERSAL);

use SAPDB::Install::Window::PackageList;

use base Wx::Dialog;

sub new{
	my ($class,$packages,@args) = @_;
	my($this ) = $class->SUPER::new(@args);
	$this->SetWindowStyleFlag($this->GetWindowStyleFlag | wxTAB_TRAVERSAL);
	$this->Move([300,200]);
	$this->SetSize([300,350]);
	$this->SetTitle('Currently Selected Components');
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'view'} = myPackageList->new($this,-1);
	my @packages = @$packages;
	$this->{'view'}->create($packages);
	unless($^O =~ /mswin/i){
		$this->{'view'}->Enable(0);
	}
	$this->{'view'}->Fit;
	$sizer->Add($this->{'view'},1,wxEXPAND | wxALL,10);
	$this->{'button'} = Wx::Button->new($this,-1,'&OK',[0,0],[-1,-1]);
	$sizer->Add($this->{'button'},0,wxALIGN_CENTER | wxTOP | wxBOTTOM, 15);	
	$this->SetSizerAndFit($sizer);
	EVT_BUTTON($this,$this->{'button'}->GetId,sub {my ($self) = @_; $self->Close(1);});
	$this->Layout;
	if($^O =~ /mswin/i){
		EVT_KILL_FOCUS($this->{'button'},sub{$this->{'button'}->SetFocus;});
		$this->{'button'}->SetDefault();
		$this->{'button'}->SetFocus;
	}
	$this->ShowModal;
	return $this;
}

sub Destroy{
	my ($self) = @_;
	while($self->GetSizer->Remove(0)) {}
	$self->{'view'}->Destroy;
	delete $self->{'view'};
	$self->{'button'}->Destroy;
	delete $self->{'button'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;
