#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Grid/CellDBEditor.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Grid::CellDBEditor;


use base Wx::PlGridCellEditor;
use SAPDB::Install::Control::Database;
use Wx qw();


sub Create {
  my ( $self, $parent, $id, $evthandler ) = @_;
  return 1 if exists $self->{'db'};
  $self->{'db'} = SAPDB::Install::Control::Database->new($parent,$id);
  $self->{'db'}->{'no_autoresize'} = 1;
  return 1;
}  

sub SetSize {
  my( $self, $size ) = @_;
  $self->{'db'}->SetSize( $size );
}

sub Show {
  my( $self, $show, $attr ) = @_;
  $self->{'db'}->Show( 1 );
}

sub EndEdit {
	my( $self, $row, $col, $grid ) = @_;
	return 0;
}

sub BeginEdit {
	my( $self, $row, $col, $grid ) = @_;
	$self->{'db'}->SetBackgroundColour($grid->GetCellBackgroundColour( $row, $col));
	$self->{'db'}->SetDBName($grid->GetCellValue( $row, $col));
	$self->{'db'}->SetFocus;
	$self->{'db'}->SetSelection(-1,-1);
	return 1;
}


sub Destroy{
	my ($self) = @_;
	if (exists $self->{'db'}){
		$self->{'db'}->Destroy;
		delete $self->{'db'};
	}
}

1;
