#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Grid/CellDriveEditor.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: 


package SAPDB::Install::Grid::CellDriveEditor;

use base Wx::PlGridCellEditor;
use SAPDB::Install::Control::DriveSelector;
use Wx::Event qw(EVT_KILL_FOCUS);
use Wx qw(wxTheApp);


sub Create {
  my ( $self, $parent, $id, $evthandler ) = @_;
  return 1 if exists $self->{'ds'};
  $self->{'ds'} = SAPDB::Install::Control::DriveSelector->new( $parent, $id);
  EVT_KILL_FOCUS($self->{'ds'},
  		sub{
			my ($ds,$evt) = @_;
			my $grid = $parent->GetParent;
			if(wxTheApp->Pending){
				$evt->Skip(1);	
			}
			else{
				bless ($grid,'SAPDB::Install::Grid::Base');
				if($grid->FindNextEditable){
					$grid->EnableCellEditControl(1);
				}
				else{
					
				}

	
			}
		}
  );	
 }

sub SetSize {
  my( $self, $size ) = @_;
  $self->{'ds'}->SetSize($size);
}

sub Show {
  my( $self, $show, $attr ) = @_;
  $self->{'ds'}->Show( $show );
}


sub EndEdit {
	my( $self, $row, $col, $grid ) = @_;
	my $changed = ($self->{'ds'}->GetValue ne
			 $grid->GetCellValue( $row, $col )); 
	
	$grid->SetCellValue( $row, $col, $self->{'ds'}->GetValue )
		 if $changed;
	
	return $changed;
}

sub BeginEdit {
	my( $self, $row, $col, $grid ) = @_;
	$self->{'ds'}->SetValue($grid->GetCellValue( $row, $col));
	$self->{'ds'}->SetFocus;
	return 1;
}


sub Destroy{
	my ($self) = @_;
	$self->{'ds'}->Destroy if $self->{'ds'};
}

1;
