#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Image.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: 

package SAPDB::Install::Image;

use Wx qw (wxSYS_COLOUR_INACTIVECAPTION);

use base Wx::Image;


sub new{
	my $class = shift;
	my ($self ) = $class->SUPER::new(@_);
	return bless($self,$class)
}

sub Copy{
	my ($self) = @_;
	return bless ($self->SUPER::Copy(),__PACKAGE__);
}

sub GreyScale{
	my ($self) = @_;
	my $size = $self->GetHeight * $self->GetWidth; 
	my $data = $self->GetData();
	my $new_data;
	my $transvalue = pack('CCC',$self->GetMaskRed,
								$self->GetMaskGreen,
	
								$self->GetMaskBlue);
	my $i = 0;
	while($i < ($size)){
		my $pixel = substr($data,$i*3,3); 
		if($transvalue eq $pixel){
		substr($new_data,$i * 3) = $pixel;
			$i++;
			next;
		}
		my ($r,$g,$b) = unpack('CCC',$pixel);
		$r = $g = $b = ($r + $g + $b) / 3;
		substr($new_data,$i * 3) = pack('CCC',$r,$g,$b);
		$i++;
	}
	$self->SetData($new_data);
	return 1;
	
}


sub Disable{
	my ($self) = @_;
	my $size = $self->GetHeight * $self->GetWidth; 
	my $data = $self->GetData();
	my $new_data;
	my $transvalue = pack('CCC',$self->GetMaskRed,
								$self->GetMaskGreen,
	
								$self->GetMaskBlue);
	
	my $disable_colour = Wx::SystemSettings::GetColour(wxSYS_COLOUR_INACTIVECAPTION);
		
	my $disable_value = pack('CCC',
								$disable_colour->Red(),
								$disable_colour->Green(),
								$disable_colour->Blue());
	my $i = 0;
	while($i < ($size)){
		my $pixel = substr($data,$i*3,3); 
		if($transvalue eq $pixel){
		substr($new_data,$i * 3) = $pixel;
			$i++;
			next;
		}
		substr($new_data,$i * 3) = $disable_value;
		$i++;
	}
	$self->SetData($new_data);
	return 1;
}


sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;