#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Portable/Helper.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: portable mode helper functions 


package SAPDB::Install::Portable::Helper;


require SDB::Common::Exporter;
our @ISA = qw (SDB::Common::Exporter);

our @EXPORT = qw (getRelPath getAbsPath);	


sub getRelPath{
	return undef 
		unless (exists $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'});

	my ($path,$is_data_path) = @_;

	my $pattern;
	
	if (exists $SAPDB::Install::Config{'SDB_PORTABLE_PROGRAMS_ROOT'}
		and !$is_data_path){
		
		$pattern = $SAPDB::Install::Config{'SDB_PORTABLE_PROGRAMS_ROOT'};		
	}
	else{
		$pattern = $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'};
	}
	
	$pattern =~ s/[\\\/]+/[\\\\\\\/]+/g;
	$pattern = '^'.$pattern; 
		
	if ($^O =~ /mswin/i){
		return undef unless $path =~ /$pattern/i;
		$path =~ s/$pattern//i;
	}
	else{
		return undef unless $path =~ /$pattern/;
		$path =~ s/$pattern//i;
	}
	$path =~ s/^[\\\/]*//;
	return $path;
}

sub getAbsPath{
	return undef 
		unless (exists $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'});

	my ($path,$is_data_path) = @_;

	return undef if $path =~ /^[\\\/]/;
	return undef if $^O =~ /mswin/i and $path =~ /^[a-z]:[\\\/]/i;
				
	if (exists $SAPDB::Install::Config{'SDB_PORTABLE_PROGRAMS_ROOT'}
		and !$is_data_path){
		return 	$SAPDB::Install::Config{'SDB_PORTABLE_PROGRAMS_ROOT'}.'/'.$path;	
	}
	else{
		return $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'}.'/'.$path;
	}
}

1;

