#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/StdIO.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc: 

package SAPDB::Install::StdIO;

require SDB::Common::Exporter;

our @ISA = qw (SDB::Common::Exporter);
our @EXPORT = qw (timeStamp print2stderr print2stdout readstdin diesoft);

use SAPDB::Install::Term::ReadKey;
use SAPDB::Install::Trace;

# set autoflush on
$| = 1;

#sub generates formated time stamp
sub timeStamp{
	my $hour=(localtime)[2];
	my $minute = (localtime)[1];
	my $second= (localtime)[0];
	my $day= (localtime)[3];
	$hour = "0$hour" if(length($hour)==1);
	$minute = "0$minute" if(length($minute)==1); 
    $second = "0$second" if(length($second)==1);
	$day = "0$day" if(length($day)==1);
	my $returnvalue=(Su,Mo,Tu,We,Th,Fr,Sa)[(localtime)[6]].", ". 
	(Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[(localtime)[4]].
	    " $day, ".((localtime)[5]+1900).
		" at $hour:$minute:$second";
	return $returnvalue;
}

our @errmsgbuf;

#sub print message to STDERR and into logfile
sub print2stderr{
    SDB::Common::Exporter::import('Wx','wxICON_ERROR','wxCENTRE')
		if $SAPDB::Install::Values::GUI_MODE;
	local $message=(@_)[0];
   ($SAPDB::Install::DEBUG or $SAPDB::Install::Values::GUI_MODE) or print STDERR $message;
	TraceMsg("ERR: $message",1,\$DEBUG,2);
	defined  $SAPDB::Install::Values::log && $SAPDB::Install::Values::log->SetMsg("STDERR: $message");
	if($SAPDB::Install::Values::GUI_MODE and not $SAPDB::Install::StartInstall::opt_b){
		push @errmsgbuf,$message;
		#my $msgbox = Wx::MessageDialog->new($SAPDB::Install::Values::gui_dlg,$message,
		#		"Error", wxICON_ERROR() | wxCENTRE());
		#$msgbox->ShowModal();
	}
	return 1;
}


#sub print message to STDOUT and into logfile
sub print2stdout{
    my $message=(@_)[0];
    ($SAPDB::Install::DEBUG or $SAPDB::Install::Values::GUI_MODE) or print $message;
	TraceMsg("OUT: $message",1,\$DEBUG,2);
    defined  $SAPDB::Install::Values::log && $SAPDB::Install::Values::log->SetMsg("STDOUT: $message");
	return 1;
}

#sub read stdin
sub readstdin{
    my ($psswrd_mode)=@_;# if true terminal echo will be disabled
    my $returnvalue;
    if($psswrd_mode){
		my $rc = SAPDB::Install::Term::ReadKey::ReadMode('noecho');
		defined $rc or print2stderr("cannot set term mode to echo off: $rc\n") and diesoft($SAPDB::Install::Values::diemsg);	
		chomp($returnvalue = SAPDB::Install::Term::ReadKey::ReadLine());	
		TraceMsg("IN: <secret>",1,\$DEBUG,2);
		print2stdout("\n");
		defined  $SAPDB::Install::Values::log && $SAPDB::Install::Values::log->SetMsg("\nSTDIN: \n");
		$rc = SAPDB::Install::Term::ReadKey::ReadMode('restore');
		defined $rc or print2stderr("cannot restore term mode\n") and diesoft($SAPDB::Install::Values::diemsg); 
   
	}
    else{
		chomp($returnvalue=<STDIN>);
		TraceMsg("IN: $returnvalue",1,\$DEBUG,2);
    	defined  $SAPDB::Install::Values::log && $SAPDB::Install::Values::log->SetMsg("\nSTDIN: $returnvalue\n");
    }
    return $returnvalue;
}

#sub print message into logfile and exite installer 
sub diesoft{
    my ($message)=@_;
    if($message =~ /\S/){
		$message="$message at ".timeStamp()."\n";
		TraceMsg("DIE: $message",1,\$DEBUG,2);
		if($^O =~ /mswin/i){
			print2stderr($message); 
		}
		else{
			print STDERR $message; 
			defined  $SAPDB::Install::Values::log && $SAPDB::Install::Values::log->SetMsg("STDERR: $message");
		}
	}
	$SAPDB::Install::Uninstall::Start::cleaner = undef;
	$SAPDB::Install::StartInstall::cleaner = undef;
	WriteTrace();
	if($SAPDB::Install::Config{'HasOwnConsole'} and !$SAPDB::Install::StartInstall::opt_b){
		print2stdout("\npress any key...");
		SAPDB::Install::Term::ReadKey::ReadMode('raw');
		SAPDB::Install::Term::ReadKey::ReadKey();
	}

	if($SAPDB::Install::Values::GUI_MODE){
		
		if($#errmsgbuf > -1){
		
			#
			# show last error message
			#
		
			my $msg;
			foreach my $line (split("\n",$errmsgbuf[$#errmsgbuf])){
				my $tmp_line = $line;
				if(length($line) > 100){
					$tmp_line =~ s/(.{100,}?[\s,;])/$1\n/g;
				}
				$msg .= $tmp_line;
			}
			$msg .= $message;
			my $msgbox = Wx::MessageDialog->new($SAPDB::Install::Values::gui_dlg,$msg,
				"Error", wxICON_ERROR() | wxCENTRE());
			$msgbox->ShowModal();
			$msgbox->Destroy;
		}
		
		die("fatal error\n");
	}
	else{
		if(defined $SAPDB::Install::Config{'TmpLDPath'} and 
			-d $SAPDB::Install::Config{'TmpLDPath'}){
			
			my $tmp = $SAPDB::Install::Config{'TmpLDPath'};
			opendir(DH,$tmp) or return $rc;
			foreach my $node (grep {not /^[.]{1,2}$/} readdir(DH)){
				unlink ("$tmp/$node");
			}
			closedir(DH);
			rmdir($tmp);
		}
		exit 1;
	}

}

1;