package  SAPDB::Install::Templates2::test::InstanceCustomTest;

use SAPDB::Install::Templates2::InstUnit;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;



our @ISA;
if($SCRIPTING){
  require Exporter;
  push @ISA,qw(Exporter);
  require Data::Dumper;
  import Data::Dumper;
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}


require Exporter;
push @ISA,qw(Exporter);
our @EXPORT = qw ( allTests );




my ($db,$tpl); 
sub setUp{
  $tpl = SAPDB::Install::Templates2::InstTemplate::new(undef,'custom')or die;
  $db = $tpl->getDBInstance();
}



sub testExistsKey{
return not  $tpl->getDBInstance()->ExistsKey('DEPENDENDPATH');
}

sub tearDown{
  undef $tpl;
  undef $db;
}

sub testUsers{
  my $p;

  $p = $db->getDBMUser();
  $p eq 'DBM' or return "Wrong dbm user: $p";
  $p= $db->getDBMPass();
  $p eq 'DBM' or return "Wrong dbm password: $p";




  $p = $db->getDBAUser();
  $p  eq 'DBADMIN' or return "Wrong dbauser user $p";
  $p = $db->getDBAPass();
  $p  eq 'SECRET' or return "Wrong dbapass $p";

  
  $p = $db->getDBAdmin();
  $p eq 'DBADMIN,SECRET' or return "Wrong dbadmin: $p";
  $p = $db->getDBManager();
  $p eq 'DBM,DBM' or return "Wrong dbmanager: $p";
#  print "p: $p\n";
  return 0;
}



sub testGetSoftwarePath{
  my $v1 = $db->getSoftwarePath();
  my $v2 = $tpl->getSoftwarePath();
  $v1 eq $v2 or return "'$v1' neq '$v2'";
  my $v3 = $tpl->GetDefault('softwarePath');
  return 0;
}

sub testGetDependendPath{
  $db->getDependendPath();
  return 0;
}
sub testSetVolstructLog{
  my $vols = $db->GetVolStructs('LOG');
#  print Dumper($vols);
  $vols = $db->setVolstructLog($vols);
#  print Dumper($db->getDBVolume());
  return 0;
}
sub testGetVolstructLog{
  my $vols = $db->getVolstructLog();
  return 0;
}

sub testGuiValidateVolStructLog{
  my $vols = $db->GetVolStructs('LOG');
  my @valRes =  $db->guiValidateVolstructLog($vols);
  return 0;
}

sub testGuiValidateVolStructData{
  my $vols = $db->GetVolStructs('DATA');
  $vols->[0]->{'Size'}=20000;
  my @valRes =  $db->guiValidateVolstructData($vols);
#  print  Dumper(\@valRes);
  return 0;
}


sub testVolStuctToString{
  my $vols = $db->GetVolStructs('DATA');
#  print Dumper($vols);
  my $s = $db->volStructToString($vols);
#  print  "$s\n";
  return 0;
}



sub testGetDBMemory{
  my $m = $db->getDBMemory();
  return 0;
}
sub testGetDBSize{
  my $s = $db->getDBSize();
#  print "Size $s\n";
  return 0;
}





sub testSetDBMemory{
  my $m = $db->getDBMemory();
  $db->setDBMemory($m);
  my $ps = $db->getDBParams();
  my $cs = $ps->{'CACHE_SIZE'};
  $cs or return "No cache size!";
  $cs eq $m or return "Wrong cache size: $cs";
  return 0;
}

sub testSetCPUCount{
  $db->setCPUCount(3);
  my $ps = $db->getDBParams();
  my $cs = $ps->{'MAXCPU'};
  $cs or return "No maxcpu";
  $cs eq 3 or return "Wrong MAXCPU: $cs";
  return 0;
}
sub testGetVolstructData{
  my $vols = $db->getVolstructData();
  return 0;
}

sub testGetLoggingStruct{
  my $ls =$db->getLoggingStruct();
  return 0;
}

sub testSetLoggingStruct{
  my $ls =$db->getLoggingStruct();
  $ls->{'LogSaveDir'} = 'logsavedir';
  $ls->{'InitialBackupDir'} = 'initialbackupdir';
  $db->setLoggingStruct($ls);
  'logsavedir' eq $db->getLogSaveDir()
    or return "Wrong logsavedir ".$db->getLogSaveDir();
  'initialbackupdir' eq $db->getInitialBackupDir()
    or return "Wrong initialbackupdir ".$db->getInitialBackupDir();
  $ls = 'AUTO[initialbackupdir2;logsavedir2]';
  $db->setLoggingStruct($ls);
  'logsavedir2' eq $db->getLogSaveDir()
    or return "Wrong logsavedir2 ".$db->getLogSaveDir();
  'initialbackupdir2' eq $db->getInitialBackupDir()
    or return "Wrong initialbackupdir2 ".$db->getInitialBackupDir();
  return 0;
}


sub testDescribe{
  my $l = $db->Describe();
#  $l = $db->GetLineForKey('initialBackupDir');
#  $l = $db->Get('initialBackupDir','no can','no subs');
#  $l = $db->hasBeenSet('loggingStruct');
#  print $l;
  return 0;
}

sub allTests{
  unitTest(__PACKAGE__);
}

1;

# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
