#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_32/sys/src/install/perl/SAPDB/Install/Wizard/Dialog/UpdateSelect.pm#1 $
# $DateTime: 2006/07/06 16:50:32 $
# $Change: 130190 $
#
# Desc:
#

package SAPDB::Install::Wizard::Dialog::UpdateSelect;

use Wx::Event qw(EVT_TEXT);

use Wx qw (	wxVERTICAL wxHORIZONTAL wxEXPAND
			wxCB_READONLY wxALL wxTOP wxRIGHT
			wxLC_REPORT);


use SAPDB::Install::Window::DBLogin;
use SAPDB::Install::Tools;
use SAPDB::Install::Misc;
use SAPDB::Install::Registry;
use SAPDB::Install::Wizard::Dialog::UpdateFinish;
use base SAPDB::Install::Wizard::Dialog::Base;
use SAPDB::Install::Service::Communication;

sub new{
	my($this ) = shift->SUPER::new(@_);
	return $this;
}


sub init(){
	my ($self,$config) = @_;
	my @dbs;
	
	$SAPDB::Install::Config::IsInstanceUpdate = 1;
	
	$self->{'db_index'} = $config->{'collector'}->instance_index;
	
	foreach my $db (sort keys(%{$self->{'db_index'}})){
		#if($self->{'db_index'}->{$db}->{'ready_to_update'}){
			push @dbs,$db;
		#}
	}
	my $db_label = Wx::StaticText->new($self,-1,'Database Name');
	$self->{'cb'} = Wx::ComboBox->new($self,-1,$dbs[0],[0,0],[120,-1],
										\@dbs,wxCB_READONLY); 
	
	EVT_TEXT($self,$self->{'cb'}->GetId,\&OnSelect);
	
	my $dbname_sizer = Wx::BoxSizer->new(wxHORIZONTAL);
	$dbname_sizer->Add($db_label,0,wxRIGHT,20);
	$dbname_sizer->Add($self->{'cb'},0);
	$self->{'login'} = SAPDB::Install::Window::DBLogin->new({'log' => 
								$config->{'container'}->Log},$self,-1);
	$self->{'list'} = Wx::ListCtrl->new( $self, -1, [0,0],[-1,-1],
                                wxLC_REPORT);
	$self->{'list'}->InsertColumn( 1, "Parameter" );
	$self->{'list'}->InsertColumn( 2, "Value" );
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$sizer->Add($dbname_sizer,1,wxEXPAND | wxALL, 50);
	$sizer->Add($self->{'login'},1,wxEXPAND | (wxALL) & (~wxTOP) , 50);
	my $topsizer = Wx::BoxSizer->new(wxHORIZONTAL);
	
	$topsizer->Add($sizer,1,wxEXPAND);
	$topsizer->Add($self->{'list'},1,wxEXPAND | wxALL,20);
	$self->OnSelect;	
	
	$self->SetAutoLayout(1);
	$self->SetSizerAndFit($topsizer);
	$self->Layout;
	$self->{'initialized'} = 1;
	return {}; 

}

sub OnSelect{
	my ($self,$evt) = @_;
	
	my $db = $self->{'cb'}->GetValue;
	$self->{'login'}->{'dbname'} = $db;
	
	my $count = 0;
	
	if($self->{'db_index'}->{$db}->{'ready_to_update'}){
		delete $self->GetWizard->{'nbutton_disabled'};
		$self->GetWizard->{'nbutton'}->Enable(1);
		$self->{'login'}->Enable(1);
	}
	else{
		$self->GetWizard->{'nbutton_disabled'} = 1;
		$self->GetWizard->{'nbutton'}->Enable(0);
		$self->{'login'}->Enable(0);
	}
	
	
	$self->{'list'}->DeleteAllItems;
	
	my $item = $self->{'list'}->InsertStringItem($count++,'Database Name');
	$self->{'list'}->SetItem($item,1,$db);
	$item = $self->{'list'}->InsertStringItem($count++,'Software Version');
	$self->{'list'}->SetItem($item,1,$self->{'db_index'}->{$db}->{'version'});
	$item = $self->{'list'}->InsertStringItem($count++,'Software Path');
	my $path = $self->{'db_index'}->{$db}->{'instroot'};
	$path = getRealPathName($path) if ($^O =~ /mswin/i);
	$self->{'list'}->SetItem($item,1,$path);
	
	unless($self->{'db_index'}->{$db}->{'ready_to_update'}){
		$item = $self->{'list'}->InsertStringItem($count++,'Update State');
		$self->{'list'}->SetItem($item,1,'Update not allowed: '.$self->{'db_index'}->{$db}->{'not_ready_reason'});
		#$item = $self->{'list'}->InsertStringItem($count++,'Cannot update because: ');
		#$self->{'list'}->SetItem($item,1,$self->{'db_index'}->{$db}->{'not_ready_reason'});
	}
	
	
	if	(exists $self->{'db_index'}->{$db}->{'registry_instancedata'} and
		defined $self->{'db_index'}->{$db}->{'registry_instancedata'}){
		$item = $self->{'list'}->InsertStringItem($count++,'Update State');
		$self->{'list'}->SetItem($item,1,'Update is pending');
		
		foreach my $param (sort keys(%{$self->{'db_index'}->{$db}->{'registry_instancedata'}})){
			my $param_name = $param;
			
			my $value = $self->{'db_index'}->{$db}->{'registry_instancedata'}->{$param};
			
			if($param =~ /OK/){
				if($value){
					$value = 'yes';
				}
				else{
					$value = 'no';
				}
			}
			elsif($value !~ /\S/){
				next;	
			}
			if($param_name =~ /SOFTWARE_OK/){
					$param_name = 'Software already installed';
				}
				if($param_name =~ /^TYPE$/){
					$param_name = 'Database Type';
				}									
				$param_name =~ s/_/\ /g;
				$param_name =~ tr/A-Z/a-z/;
				$param_name =~ s/^(\w)/\u$1/g;
				$param_name =~ s/\s(\w)/\ \u$1/g;
			
			$item = $self->{'list'}->InsertStringItem($count++,$param_name);
			$self->{'list'}->SetItem($item,1,$value);
		}
	}
	elsif($self->{'db_index'}->{$db}->{'ready_to_update'}){
		$item = $self->{'list'}->InsertStringItem($count++,'Update State');
		$self->{'list'}->SetItem($item,1,'New Update');
	}
	
	
	$self->{'list'}->SetColumnWidth(0,-1);
	$self->{'list'}->SetColumnWidth(1,-1);	
	if(defined $evt){
		$evt->Skip(1);
	}
	return 1;
}



sub Process{
	my ($self,$config) = @_;
	
	$config->{'comm'} = SAPDB::Install::Service::Communication->new();
	
	unless($config->{'comm'}->start){
		$self->SetError('Cannot start communication server!',$config->{'comm'}->last_error);
		return undef;
	}
	
	unless ($^O =~ /mswin/i){
		my ($indep_data,$indep_prog) = readIndepPath();
		checkIniLock ($indep_data.'/config/Databases.ini_lock');
		checkIniLock ($SAPDB::Install::Values::ini_path.'_lock');
	}	
	
	my $session = $self->{'login'}->connect;
	
	unless(defined $session){
		$self->SetError('Connect failed!',$self->{'login'}->{'last_err'});
		return undef;
	}

	$session->release;
	
	
	my $finish = {
			'name' => 'Finalizing database update',
			'dlg' => SAPDB::Install::Wizard::Dialog::UpdateFinish->new($self->GetWizard,-1)
	};
	
	
	my $dbupdate = {};
	$dbupdate->{'dbname'} = $self->{'cb'}->GetValue;
	$dbupdate->{'user_passwd'} = $self->{'login'}->{'user_passwd'};
	$dbupdate->{'instroot'} =
		$config->{'collector'}->instance_index->
		{$dbupdate->{'dbname'}}->{'instroot'}; 	
	
	$dbupdate->{'version'} =
		$config->{'collector'}->instance_index->
		{$dbupdate->{'dbname'}}->{'version'}; 		
	
	if(	defined $config->{'collector'}->instance_index->
		{$dbupdate->{'dbname'}}->{'registry_instancedata'}){
		
		$dbupdate->{'registry_instancedata'} = 
			$config->{'collector'}->instance_index->
			{$dbupdate->{'dbname'}}->{'registry_instancedata'};
		
		if($dbupdate->{'registry_instancedata'}->{'SOFTWARE_OK'}){
			$self->GetWizard->SkipStep('Summary of installation settings');
			$self->GetWizard->SkipStep('Checking installed software, please wait');
			$self->GetWizard->SkipStep('Software installation');	
			$self->GetWizard->SkipStep('Prepare software');
		}
		else{
			$self->GetWizard->SkipStep('Summary of installation settings',0);
			$self->GetWizard->SkipStep('Checking installed software, please wait',0);
			$self->GetWizard->SkipStep('Software installation',0);	
			$self->GetWizard->SkipStep('Prepare software',0);
		}
	
	}
	
	
	my @steps = ();
	
	if(exists $dbupdate->{'registry_instancedata'} && $dbupdate->{'registry_instancedata'}->{'INSTANCE_CHECK_OK'}){
		if($^O =~ /mswin/i or not $config->{'comm'}->state->{'is_updatable'}){
			unless($config->{'comm'}->stop){
				$self->SetError('Cannot stop communication server',$config->{'comm'}->last_error);
				return undef;
			}
		}	
	}
	else{
		require SAPDB::Install::Wizard::Dialog::UpdateCheck;
		my $check  = {
			'name' => 'Checking database for update',
			'dlg' => SAPDB::Install::Wizard::Dialog::UpdateCheck->new($self->GetWizard,-1)
		};
		push @steps,[$check,undef];
	}
	
	
	
	push @steps,[$finish,'Software installation'];
	
	
	return {'AddNewSteps' => \@steps,
			'dbupdate' => $dbupdate
			};
}


sub BackInit{
	my ($self,$config) = @_;
	$self->GetWizard->SkipStep('Summary of installation settings',0);
	$self->GetWizard->SkipStep('Checking installed software, please wait',0);
	$self->GetWizard->SkipStep('Software installation',0);	
	$self->GetWizard->SkipStep('Prepare software',0);
	if(defined $config->{'dbupdate'}){
		delete $config->{'dbupdate'};
	}
	if(defined $self->{'login'}){
		$self->{'login'}->release;
	}
	return 1;
}

sub Back{
	my ($self,$config) = @_;
	$SAPDB::Install::Config::IsInstanceUpdate = 0;
	delete $self->GetWizard->{'nbutton_disabled'};
	$self->GetWizard->{'nbutton'}->Enable(1);
	return 1;
}	
	

sub Destroy{
	my ($self) = @_;
	if(defined $self->GetSizer){
		while($self->GetSizer->Remove(0)){}
	}
	if(defined $self->{'list'}){
		$self->{'list'}->Destroy;
		delete $self->{'list'};
	}
	if(defined $self->{'cb'}){
		$self->{'cb'}->Destroy;
		delete $self->{'cb'};
	}
	if(defined $self->{'login'}){
		$self->{'login'}->Destroy;
		delete $self->{'login'};
	}
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;
