#############################################################################
## Name:        ext/pperl/splashfast/SplashFast.pm
## Purpose:     Wx::Perl::SplashFast -> Show a splash before loading Wx.
## Author:      Graciliano M. P.
## Modified by:
## Created:     30/06/2002
## RCS-ID:      $Id: //sapdb/V76/c_00/b_32/sys/src/install/perl/SDB/Wx/Splash.pm#1 $
## Copyright:   (c) 2002-2003 Graciliano M. P.
## Licence:     This program is free software; you can redistribute it and/or
##              modify it under the same terms as Perl itself
#############################################################################

use strict;

package Wx::PNGHandler;

our @ISA = qw(Wx::ImageHandler);

1;

package SDB::Wx::Splash;

our $Window;

our $VERSION = '0.02';

sub import {
  SDB::Wx::Splash::new(@_) if @_ > 1;
}

sub new {
	my ($class, $archivename, $filename) = @_;

	SDB::Wx::Splash::App->new ();
	Wx::InitAllImageHandlers() ;

	my $spl_center = Wx::constant ('wxSPLASH_CENTRE_ON_SCREEN', 0);
	my $spl_timeout = Wx::constant ('wxSPLASH_TIMEOUT', 0);

	my $img = Wx::Image->new ();
  	my $hnd = Wx::PNGHandler->new ();
	my $ah = SDB::Common::Archive::Tar::new ($archivename);
	my $fh = $ah->open ($filename);
	$hnd->LoadFile ($img, $fh);

	my $bmp = Wx::Bitmap->new ($img);
	
	$Window = Wx::SplashScreen->new ($bmp, $spl_center, -1, undef, -1);
	return ($Window);
}

package SDB::Wx::Splash::App;

our @ISA = qw (Wx::_App);

sub OnInit {
	return 1;
}

package Wx;

our $VERSION = '0.26';

sub wxPL_STATIC ();

sub _wx_boot($$) {
	if ($_[0] eq 'Wx' ) {
		require XSLoader;
		XSLoader::load( $_[0], $_[1] );
	} else {
		no strict 'refs';
		my $t = $_[0]; $t =~ tr/:/_/;
		&{"_boot_$t"}( $_[0], $_[1] );
	}
}

_wx_boot ('Wx', $VERSION);
_boot_Constant ('Wx', $VERSION);
_boot_GDI ('Wx', $VERSION);

Load ();

1;
